using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;
using CommonTypes;

namespace LibraryClient
{
	class LibraryClient
	{
		public static void Main()
		{
			// Create new client TCP channel and register it
			TcpChannel channel = new TcpChannel();
			ChannelServices.RegisterChannel(channel);
			Console.WriteLine("Registered new client TCP channel.");
			
			// Activate the Library remote object
			Library remoteLibrary = (Library)
				Activator.GetObject(typeof(Library),
				"tcp://localhost:12345/Library");
			Console.WriteLine("The Library object activated.");

			// Retrieve the books from the server
			Book[] books = remoteLibrary.GetBooks();

			// Update the first book (through a server call)
			books[0].Author = "Author changed";

			// Print books (through a series of server calls)
			foreach (Book book in books)
			{
				Console.WriteLine("(Author: {0}; Title: {1}, ISBN: {2})",
					book.Author, book.Title, book.Isbn);
			}
		}	
	}
}
