using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;
using CommonTypes;

namespace LibraryServer
{
	class LibraryServer
	{
		const int LISTENING_PORT = 12345;
        
		static void Main(string[] args)
		{
			// Create the remoting TCP channel and register it
			TcpChannel channel = new TcpChannel(LISTENING_PORT);
			ChannelServices.RegisterChannel(channel);
			
			// Register the Library class as singleton server activated object
			RemotingConfiguration.RegisterWellKnownServiceType(
				typeof(CommonTypes.Library), "Library", 
				WellKnownObjectMode.Singleton);
            
			Console.WriteLine("Library remoting server is " +
				"listening on TCP port {0}", LISTENING_PORT);
			Console.WriteLine("Press [Enter] to exit.");
			Console.ReadLine();
		}
	}
}
